Key derivation functions: HKDF (RFC 5869), PBKDF2 (RFC 2898), scrypt (RFC 7914)